<!DOCTYPE html>
<html>

<head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/jquery@3.6.0/dist/jquery.slim.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular.min.js"></script>
</head>

<style>
  #usersScrollable {
    height: 500px;
    overflow-y: scroll;
  }
</style>

<body>

  <div ng-app="myApp" ng-controller="myCtrl">

    <div class="container">
      <h2>Employees</h2>
      <p>Total items {{totalElements}}</p>
      <div id="usersScrollable" when-scroll-ends="more()">
        <table class="table table-hover">
          <thead>
            <tr>
              <th>#id</th>
              <th>name</th>
            </tr>
          </thead>
          <tbody>
            <tr ng-repeat="employee in employees">
              <td>{{ employee.id }}</td>
              <td>{{ employee.name }}</td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>

  </div>

  </div>

  <script>
    var app = angular.module('myApp', []);
    app.controller('myCtrl', function ($scope, $http) {

      $scope.page = 0;
      $scope.pageSize = 10;
      $scope.totalItems = 0;
      $scope.employees = [];

      $scope.more = function () {
        console.log("more -> Getting employees data")
        //$scope.employees = []
        $http.get("/employees?page=" + $scope.page + "&pageSize=" + $scope.pageSize)
          .then(function (response) {
            let {content, totalElements} = response.data;
            $scope.employees = [...$scope.employees, ...content];
            $scope.totalElements = totalElements;
            $scope.page = $scope.page + 1;
          });
      }

     $scope.less = function () {
        console.log("less -> Getting employees data")
        if ($scope.page > 0) {
          $scope.page = $scope.page - 1;
          $http.get("/employees?page=" + $scope.page + "&pageSize=" + $scope.pageSize)
          .then(function (response) {
            let {content, totalElements} = response.data;
            $scope.employees = content;
            $scope.totalElements = totalElements;
          });
        }
      }

      $scope.more();

    });
    app.directive('whenScrollEnds', function ($window) {
      return {
        restrict: "A",
        link: function (scope, elm, attr) {
          var raw = elm[0];

          raw.addEventListener('scroll', function () {
            if (raw.scrollTop > 0 && (raw.scrollTop + raw.clientHeight) >= (raw.scrollHeight)) {
              scope.$apply(attr.whenScrollEnds);
            }
          });
        }
      };
    });
    app.directive('whenScrollTop', function ($window) {
      return {
        restrict: "A",
        link: function (scope, elm, attr) {
          var raw = elm[0];

          raw.addEventListener('scroll', function () {
            if (raw.scrollTop == 0) {
              raw.scrollTop = (raw.scrollHeight - raw.clientHeight) - 1;
              scope.$apply(attr.whenScrollTop);
            }
          });
        }
      };
    });
  </script>

</body>

</html>